diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/daemon/common/commonSwarming.ml ./src/daemon/common/commonSwarming.ml
--- ./src/daemon/common/commonSwarming.ml	2006-05-20 01:43:54.000000000 +0200
+++ ./src/daemon/common/commonSwarming.ml	2006-05-25 20:48:14.000000000 +0200
@@ -2242,70 +2194,211 @@
 (*                                                                       *)
 (*************************************************************************)
 
-let find_range up =
-  clean_ranges up;
+let uploader_ranges_fold_left f acc l =
+  let rec aux acc l =
+    match l with
+    | [] -> acc
+    | h :: q -> aux (f acc h) q
+  in aux acc l
+
+(** Find a range to upload from [up], that is at most [range_size]
+    bytes long (split some range if necessary) *)
+
+(* Is merging at all useful ? Once range starts downloading, they can
+   no longer be merged, so it should be very rare... *)
+let allow_merge_ranges = true
+
+type ranges_cluster = {
+  cluster_ranges: range list;
+  cluster_nuploading: int;
+  cluster_size: Int64.t
+}    
+
+let dummy_ranges_cluster = {
+  cluster_ranges = [];
+  cluster_nuploading = 0;
+  cluster_size = 0L
+}
+
+let find_range up range_size =
+
+  (** merge two consecutive ranges in the first, if possible;
+      Return true if successful *)
+  let merge_ranges r r2 =
+    match r.range_next with
+    | None -> false
+    | Some rr ->
+	if rr != r2 ||
+	  r.range_end < r2.range_begin ||
+	  r2.range_nuploading > 0 then false
+	else begin
+	  r.range_end <- r2.range_end;
+	  r.range_next <- r2.range_next;
+	  (match r.range_next with
+	  | None -> ()
+	  | Some r3 ->
+	      r3.range_prev <- Some r);
+	  true
+	end in
+
+  remove_completed_uploader_ranges up;
 
   let b =
     match up.up_block with
-      None -> raise Not_found
+    | None -> 
+	if debug_all then
+	  lprintf_nl "find_range: uploader had no block selected";
+	raise Not_found
     | Some b -> b
   in
-  let r = b.block_ranges in
-
   let t = up.up_t in
-
   match file_state t.t_file with
   | FilePaused
   | FileAborted _
-  | FileCancelled -> raise Not_found
-  | _ ->
-
-      let rec iter limit r =
-
-(* let use a very stupid heuristics: ask for the first non-used range.
-we thus might put a lot of clients on the same range !
-*)
-
-        if not (in_uploader_ranges r up.up_ranges) &&
-          r.range_current_begin < r.range_end &&
-          r.range_current_begin >= up.up_block_begin &&
-          r.range_end <= up.up_block_end &&
-          r.range_nuploading < limit
-        then begin
-            let key = r.range_current_begin, r.range_end, r in
-            up.up_ranges <- up.up_ranges @ [key];
-            r.range_nuploading <- r.range_nuploading + 1;
-            if r.range_current_begin = r.range_end then
-              lprintf_nl "error: range is empty error";
-            key
-          end else
-        match r.range_next with
-          None -> raise Not_found
-        | Some rr -> iter limit rr
-      in
-      try
-(* try normal ranges *)
-        iter !!sources_per_chunk r
-      with Not_found ->
-(* force maximal uploading otherwise to finish it *)
-          iter max_int r
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         range_range                                   *)
-(*                                                                       *)
-(*************************************************************************)
-
-let range_range r = (r.range_current_begin, r.range_end)
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         received                                      *)
-(*                                                                       *)
-(*************************************************************************)
+  | FileCancelled 
+  | FileShared
+  | FileNew
+  | FileDownloaded -> 
+      lprintf_nl "find_range: file in bad state";
+      raise Not_found
+  | FileDownloading
+  | FileQueued ->
+      if debug_all then
+	lprintf_nl "find_range: is there a range of size %Ld in [%Ld-%Ld] for %d ?" 
+	  range_size up.up_block_begin up.up_block_end (client_num up.up_client);
+      let correct_range r =
+	not (in_uploader_ranges r up.up_ranges) &&
+	  r.range_begin < r.range_end &&
+	  r.range_begin >= up.up_block_begin &&
+	  r.range_begin < up.up_block_end in
+      (* pick the first correct cluster with fewest uploaders 
+	 We're not trying to get a range that's at least as big as
+	 [range_size] bytes - that would prevent partially downloaded
+	 ranges from being completed first *)
+      let rec iter acc r =
+	let best_cluster =
+	  if not (correct_range r) then acc
+	  else 
+	    (* find if they're ranges to merge ahead *)
+	    let rec iter_cluster r cluster =
+	      if debug_all then
+		lprintf_nl "[%Ld-%Ld] " r.range_begin r.range_end;
+	      let cluster = { cluster with
+		cluster_ranges = r :: cluster.cluster_ranges;
+		cluster_size = cluster.cluster_size ++ 
+		  (r.range_end -- r.range_begin)
+	      } in
+	      if not allow_merge_ranges ||
+		cluster.cluster_size >= range_size then cluster 
+	      else
+		match r.range_next with
+		| None -> cluster
+		| Some rr ->
+		    if rr.range_begin = r.range_end &&
+		      correct_range rr && rr.range_nuploading = 0 then 
+		      iter_cluster rr cluster
+		    else cluster in
+
+	    let cluster = 
+	      iter_cluster r { dummy_ranges_cluster with
+		cluster_nuploading = r.range_nuploading } in
+	    if debug_all then
+	      lprint_newline ();
+	    if acc.cluster_ranges = [] then cluster
+	    else
+	      (* find a range with as few uploaders as possible *)
+	      let cmp = compare acc.cluster_nuploading
+		cluster.cluster_nuploading in
+	      if cmp < 0 then acc
+	      else cluster in
+
+	(* fast exit, and why I didn't use an iterator :/ 
+	   Could have used an exception, but I don't like that ;) *)
+	if best_cluster.cluster_ranges <> [] &&
+	  best_cluster.cluster_nuploading = 0 then best_cluster
+	else
+	  match r.range_next with
+	  | None -> best_cluster
+	  | Some rr -> iter best_cluster rr in
+
+      let best_cluster = iter dummy_ranges_cluster b.block_ranges in
+      match List.rev best_cluster.cluster_ranges with
+      | [] -> 
+	  if debug_all then
+	    lprintf_nl "find_range: no correct range found!";
+	  raise Not_found
+      | r :: q ->
+	  if not (List.for_all (merge_ranges r) q) then
+	    lprintf_nl "find_range: ranges did not merge as well as planned";
+	  split_range r (min (r.range_begin ++ range_size)
+	   up.up_block_end);
+	  if debug_all then begin
+	    lprintf "=> [%Ld-%Ld], left:" r.range_begin r.range_end;
+	    iter_block_ranges (fun r ->
+	      lprintf " [%Ld-%Ld]" r.range_begin r.range_end
+	    ) b;
+	    lprint_newline ();
+	  end;
+	  let key = r.range_begin, r.range_end, r in
+	  up.up_ranges <- up.up_ranges @ [key];
+	  r.range_nuploading <- r.range_nuploading + 1;
+	  key
+
+(** range accessor(s) *)
+
+let range_range r = (r.range_begin, r.range_end)
+
+(** Data has been received from uploader [up]. Transfer data to file
+    and update uploader ranges.
+    Data = String.sub [str] [string_begin] [string_len] *)
+
+let received up file_begin str string_begin string_len =
+  assert (string_begin >= 0);
+  assert (string_len >= 0);
+  assert (string_begin + string_len <= String.length str);
 
-let received (up : uploader) (file_begin : Int64.t)
-  (str:string) (string_begin:int) (string_len:int) =
+(*
+  let debug_bad_write r string_pos =
+    if !verbose then begin
+      let t = up.up_t in
+      let s = t.t_s in
+      lprintf_nl "BAD WRITE in %s for range %Ld-%Ld (string_pos %d)"
+        (file_best_name t.t_file) r.range_begin r.range_end string_pos;
+      lprintf_nl "  received: file_pos:%Ld string:%d %d"
+        file_begin string_begin string_len;
+      lprintf_nl "  ranges:";
+      List.iter (fun (_,_,r) ->
+        lprintf_n "     range: %Ld-%Ld"
+          r.range_begin
+          r.range_end;
+        (match r.range_next with
+          | None -> ()
+          | Some rr ->
+              lprintf "  next: %Ld" rr.range_begin);
+        (match r.range_prev with
+          | None -> ()
+          | Some rr ->
+              lprintf "  prev: %Ld" rr.range_begin);
+        lprint_newline ();
+        let b = r.range_block in
+        lprintf_n "        block: %d[%c] %Ld-%Ld [%s]"
+          b.block_num
+          s.s_verified_bitmap.[b.block_num]
+          b.block_begin b.block_end
+          (match s.s_blocks.(b.block_num) with
+            | EmptyBlock -> "empty"
+            | PartialBlock _ -> "partial"
+            | CompleteBlock -> "complete"
+            | VerifiedBlock -> "verified"
+          );
+        let br = b.block_ranges in
+        lprintf " first range: %Ld(%Ld)"
+          br.range_begin
+          (br.range_end -- br.range_begin);
+        lprint_newline ();
+      ) up.up_ranges
+    end;
+  if !exit_on_error then exit 2 in *)
 
   if string_len > 0 then
     let file_end = file_begin ++ (Int64.of_int string_len) in
@@ -2316,188 +2409,79 @@
 (* TODO: check that everything we received has been required *)
     let t = up.up_t in
     let s = t.t_s in
-    try
-
-      List.iter (fun (_,_,r) ->
-          if r.range_current_begin < file_end &&
-            r.range_end > file_begin then begin
-
-              let file_end = min file_end r.range_end in
-              let written_len = file_end -- r.range_current_begin in
-
-              begin
-                match file_state t.t_file with
-                | FilePaused
-                | FileAborted _
-                | FileCancelled -> ()
-                | _ ->
-
-                    let string_pos = string_begin +
-                        Int64.to_int (r.range_current_begin -- file_begin) in
-                    let string_length = Int64.to_int written_len in
-
-                    if
-                      string_pos < 0 ||
-                      string_pos < string_begin ||
-                      string_len < string_length then begin
-                        if !verbose then
-                        begin
-                        lprintf_nl "BAD WRITE in %s for range %Ld-%Ld (string_pos %d)"
-                          (file_best_name t.t_file) r.range_begin r.range_end string_pos;
-                        lprintf_nl "  received: file_pos:%Ld string:%d %d"
-                          file_begin string_begin string_len;
-                        lprintf_nl "  ranges:";
-                        List.iter (fun (_,_,r) ->
-                            lprintf_n "     range: %Ld-[%Ld]-%Ld"
-                              r.range_begin r.range_current_begin
-                              r.range_end;
-                            (match r.range_next with
-                                None -> ()
-                              | Some rr ->
-                                  lprintf "  next: %Ld" rr.range_begin);
-                            (match r.range_prev with
-                                None -> ()
-                              | Some rr ->
-                                  lprintf "  prev: %Ld" rr.range_begin);
-                            lprint_newline ();
-                            let b = r.range_block in
-                            lprintf_n "        block: %d[%c] %Ld-%Ld [%s]"
-                              b.block_num
-                              s.s_verified_bitmap.[b.block_num]
-                              b.block_begin b.block_end
-                              (match s.s_blocks.(b.block_num) with
-                                EmptyBlock -> "empty"
-                              | PartialBlock _ -> "partial"
-                              | CompleteBlock -> "complete"
-                              | VerifiedBlock -> "verified"
-                            );
-                            let br = b.block_ranges in
-                            lprintf " first range: %Ld(%Ld)"
-                              br.range_begin
-                              (br.range_end -- br.range_current_begin);
-                            lprint_newline ();
-                        ) up.up_ranges;
-                        end;
-                        if !exit_on_error then exit 2
-                      end else
-                    if string_length > 0 then
-                      match s.s_networks with
-                        [] -> assert false
-                      | t :: _ when t.t_primary ->
-                          file_write t.t_file
-                            r.range_current_begin
-                            str string_pos string_length;
-                      | _ -> ()
-              end;
-              range_received (Some t) r r.range_current_begin file_end;
-
-            end
-      ) up.up_ranges;
-      clean_ranges up
-    with e ->
-        raise e
-
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         present_chunks                                *)
-(*                                                                       *)
-(*************************************************************************)
-
-let present_chunks s =
-  let nblocks = Array.length s.s_blocks in
-(*  lprintf "present_chunks...%d blocks\n" nblocks; *)
-
-  let rec iter_block_out i block_begin list =
-    if debug_present_chunks then
-      lprintf_nl "iter_block_out %d bb: %Ld"
-        i block_begin;
-
-    if i = nblocks then List.rev list else
-    let block_end = compute_block_end s i in
-    match s.s_blocks.(i) with
-      EmptyBlock ->
-        iter_block_out (i+1) block_end list
-    | CompleteBlock | VerifiedBlock ->
-        let block_begin = compute_block_begin s i in
-        iter_block_in (i+1) block_end block_begin list
-    | PartialBlock b ->
-        iter_range_out i block_end block_begin b.block_ranges  list
-
-  and iter_block_in i block_begin chunk_begin list =
-    if debug_present_chunks then
-      lprintf_nl "iter_block_in %d bb: %Ld cb:%Ld"
-        i block_begin chunk_begin
-      ;
-
-    if i = nblocks then
-      let list = (chunk_begin, s.s_size) :: list in
-      List.rev list
-    else
-    let block_end = compute_block_end s i in
-    match s.s_blocks.(i) with
-      EmptyBlock ->
-        iter_block_out (i+1) block_end ( (chunk_begin, block_begin) :: list)
-    | CompleteBlock | VerifiedBlock ->
-        iter_block_in (i+1) block_end chunk_begin list
-    | PartialBlock b ->
-        iter_range_in i block_end
-          chunk_begin block_begin b.block_ranges list
-
-  and iter_range_out i block_end block_begin r list =
-    if debug_present_chunks then
-      lprintf_nl "iter_range_out %d nb: %Ld bb:%Ld"
-        i block_end block_begin;
-
-    if r.range_begin > block_begin then
-      iter_range_in i block_end block_begin r.range_begin r list
+    match file_state t.t_file with
+    | FilePaused
+    | FileAborted _
+    | FileCancelled 
+    | FileShared
+    | FileNew
+    | FileDownloaded -> 
+	if !verbose then
+	  lprintf_nl "CommonSwarming.received: wrong file state";
+	()
+    | FileDownloading
+    | FileQueued ->
+	try
+	  List.iter (fun (_,_,r) ->
+    (* was: r.range_begin < file_end && r.range_end > file_begin *)
+            if r.range_begin >= file_begin &&
+              r.range_begin < file_end then 
+		let file_end = min file_end r.range_end in
+		let written_len = file_end -- r.range_begin in
+                let string_pos = string_begin +
+                  Int64.to_int (r.range_begin -- file_begin) in
+                let string_length = Int64.to_int written_len in
+		(* None of those conditions can happen anymore *)
+(*                if string_pos < 0 || 
+                  string_pos < string_begin || 
+                  string_len < string_length then 
+		    debug_bad_write r string_pos
+		  else *)
+                  if string_length > 0 then
+		    match s.s_networks with
+                    | [] -> assert false
+		    | tprim :: _ ->
+			assert (tprim.t_primary);
+                        file_write tprim.t_file
+                          r.range_begin
+                          str string_pos string_length;
+			range_received (Some t) r r.range_begin file_end;
+	  ) up.up_ranges;
+	  remove_completed_uploader_ranges up
+	with e ->
+	  remove_completed_uploader_ranges up;
+          raise e
+
+(** compute the list of present intervals of a swarmer *)
+
+let present_intervals s =
+  (* intervals is a reversed list of intervals *)
+  let append_interval ((interval_begin, interval_end) as interval) intervals =
+    (* remove void intervals *)
+    if interval_begin = interval_end then intervals
     else
+      match intervals with
+      | [] -> [interval]
+      | (last_interval_begin, last_interval_end) :: other_intervals  ->
+	  if last_interval_end < interval_begin then
+	    interval :: intervals
+	  else 
+	    (* coalescing intervals *)
+	    (last_interval_begin, interval_end) :: other_intervals in
 
-    if r.range_current_begin > block_begin then begin
-        if r.range_current_begin < r.range_end then
-          let list = (r.range_begin, r.range_current_begin) :: list in
-          match r.range_next with
-            None ->
-              iter_block_out (i+1) block_end list
-          | Some rr ->
-              iter_range_out i block_end r.range_end rr list
-        else
-        match r.range_next with
-          None ->
-            iter_block_in (i+1) block_end r.range_begin list
-        | Some rr ->
-            iter_range_in i block_end
-              r.range_begin r.range_end rr list
-      end else
-    match r.range_next with
-      None ->
-        iter_block_out (i+1) block_end list
-    | Some rr ->
-        iter_range_out i block_end r.range_end rr list
-
-
-  and iter_range_in i block_end chunk_begin chunk_end r list =
-    if debug_present_chunks then
-      lprintf_nl "iter_range_in %d bn: %Ld cb:%Ld ce: %Ld"
-        i block_end chunk_begin chunk_end;
-
-    if r.range_current_begin < r.range_end then
-      let list = (chunk_begin, r.range_current_begin) :: list in
-      match r.range_next with
-        None ->
-          iter_block_out (i+1) block_end list
-      | Some rr ->
-          iter_range_out i block_end r.range_end rr list
-    else
-    match r.range_next with
-      None ->
-        iter_block_in (i+1) block_end chunk_begin list
-    | Some rr ->
-        iter_range_in i block_end chunk_begin r.range_end rr list
-  in
-  let chunks = iter_block_out 0 zero [] in
-(*  lprintf "present_chunks done\n"; *)
-  chunks
+  List.rev (
+    array_fold_lefti (fun acc i b -> 
+      match s.s_blocks.(i) with
+      | EmptyBlock -> acc
+      | CompleteBlock | VerifiedBlock ->
+	  append_interval (compute_block_begin s i, compute_block_end s i) acc
+      | PartialBlock b ->
+	  let acc, last_interval_end =
+	    block_ranges_fold (fun (acc,  lie) r ->
+	      (append_interval (lie, r.range_begin) acc, r.range_end)
+	    ) (acc, compute_block_begin s i) b in
+	  append_interval (last_interval_end, compute_block_end s i) acc
+    ) [] s.s_blocks)
 
 (*************************************************************************)
 (*                                                                       *)
@@ -2505,223 +2489,99 @@
 (*                                                                       *)
 (*************************************************************************)
 
-let propagate_chunk t1 ts pos1 size =
+type chunk_occurrence = t * int * Int64.t (* frontend, chunk number, offset *)
 
-  (*
-  List.iter (fun (t2, i2, pos2) ->
-      lprintf "Should propagate chunk from %s %Ld to %s %Ld [%Ld]\n"
+type chunk_occurrences = {
+  mutable occurrence_present : chunk_occurrence list;
+  mutable occurrence_missing : chunk_occurrence list;
+}
+
+let propagate_chunk t1 pos1 size destinations =
+  List.iter (fun (t2, j2, pos2) ->
+    if t1 != t2 || pos1 <> pos2 then begin
+      lprintf_nl "Should propagate chunk from %s %Ld to %s %Ld [%Ld]"
         (file_best_name t1.t_file) pos1
         (file_best_name t2.t_file) pos2 size;
       Unix32.copy_chunk (file_fd t1.t_file)  (file_fd t2.t_file)
       pos1 pos2 (Int64.to_int size);
+      set_frontend_bitmap_2 t2 j2
+    end
+  ) destinations
 
-      set_toverify_block t2 i2;
-      set_verified_block t2 i2;
-  ) ts
-*)
-  ()
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         duplicate_chunks                              *)
-(*                                                                       *)
-(*************************************************************************)
-
-(* This is the least aggressive version. I was thinking of computing
-checksums for all possible schemas for all files, to be able to
-move chunks from/to BT files from/to ED2k files. *)
+let dummy_chunk_occurrences () = 
+  { occurrence_present = []; occurrence_missing = [] }
 
 let duplicate_chunks () =
-  (*
   let chunks = Hashtbl.create 100 in
-  HS.iter (fun t ->
-      let rec iter i len pos bsize size =
-        if i < len then
-          let c = {
-              chunk_uid = t.t_checksums.(i);
-              chunk_size = min (size -- pos) bsize;
-            } in
-          let (has, has_not) = try
-              Hashtbl.find chunks c
-            with _ ->
-                let sw = (ref [], ref []) in
-                Hashtbl.add chunks c sw;
-                sw
-          in
-          let sw = if t.t_verified_bitmap.[i] = '3' then has else has_not in
-          sw := (t, i, pos) :: !sw;
-          iter (i+1) len (pos ++ bsize) bsize size
-      in
-      iter 0 (Array.length t.t_checksums) zero t.t_block_size t.t_size
-  ) swarmers_by_num;
-  Hashtbl.iter (fun c (has, has_not) ->
-      match !has, !has_not with
-        _ ,  []
-      | [], _ -> ()
-      | (t, _, pos) :: _, ts ->
-          propagate_chunk t ts pos c.chunk_size
+  HS.iter (fun s ->
+    List.iter (fun t ->
+      let nchunks = String.length t.t_converted_verified_bitmap in
+      match t.t_verifier with
+      | Verification uids when Array.length uids = nchunks ->
+	  let rec iter j len pos =
+            if j < len then
+              let c = {
+		chunk_uid = uids.(j);
+		chunk_size = min (s.s_size -- pos) t.t_chunk_size;
+              } in
+              let occurrences = 
+		try
+		  Hashtbl.find chunks c
+		with Not_found ->
+                  let occurrences = dummy_chunk_occurrences () in
+                  Hashtbl.add chunks c occurrences;
+                  occurrences in
+	      (match t.t_converted_verified_bitmap.[j] with
+	      | '0' | '1' ->
+		occurrences.occurrence_missing <- 
+		  (t, j, pos) :: occurrences.occurrence_missing
+	      | '2' -> ()
+	      | '3' ->
+		occurrences.occurrence_present <- 
+		  (t, j, pos) :: occurrences.occurrence_present
+	      | _ -> assert false);
+              iter (j+1) len (pos ++ t.t_chunk_size)
+	  in
+	  iter 0 (String.length t.t_converted_verified_bitmap) zero
+      | _ -> ()
+    ) s.s_networks
+  ) swarmers_by_name;
+  Hashtbl.iter (fun c occurrences ->
+    match occurrences.occurrence_present, occurrences.occurrence_missing with
+    | _ , []
+    | [], _ -> ()
+    | (t, _, pos) :: _, missing ->
+        propagate_chunk t pos c.chunk_size missing
   ) chunks
-*)
-  ()
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         set_checksums                                 *)
-(*                                                                       *)
-(*************************************************************************)
-
-
-(* TODO: where is this used ? check that the fact of using the UID for
-  small files does not create any problem. *)
-let get_checksums t =
-  match t.t_verifier with
-    Verification tab -> tab
-  | _ -> [||]
-
-
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         primary (internal)                            *)
-(*                                                                       *)
-(*************************************************************************)
-
-let primary t = t.t_primary
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         set_verified_bitmap                           *)
-(*                                                                       *)
-(*************************************************************************)
-
-let set_verified_bitmap primary t bitmap =
-(*  t.t_verified_bitmap <- bitmap; *)
-
-  for i = 0 to String.length bitmap - 1 do
-
-    match bitmap.[i] with
-    | '2' ->
-        if t.t_converted_verified_bitmap.[i] < '2' then begin
-            t.t_ncomplete_blocks <- t.t_ncomplete_blocks + 1;
-            t.t_converted_verified_bitmap.[i] <- '2'
-          end
-
-    | '3' ->
-(*        lprintf "Setting 3 on %d\n" i;        *)
-        t.t_converted_verified_bitmap.[i] <- '3';
-        if primary then
-          let s = t.t_s in
-          List.iter (fun i ->
-(*              lprintf "Should set %d\n" i; *)
-              match s.s_blocks.(i) with
-                CompleteBlock ->
-(*                  lprintf "CompleteBlock\n"; *)
-                  set_verified_block s i
-              | EmptyBlock | PartialBlock _ ->
-(*                  lprintf "EmptyBlock/PartialBlock\n"; *)
-                  set_completed_block None s i;
-(*                  lprintf "set_verified_block\n"; *)
-                  set_verified_block s i
-              | VerifiedBlock ->
-(*                  lprintf "Block already verified\n" *)
-                  ()
-          ) t.t_blocks_of_chunk.(i);
-          if t.t_converted_verified_bitmap.[i] <> '3' then
-            lprintf_nl "FIELD AS BEEN CLEARED"
-    | _ -> ()
-  done
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         verified_bitmap                               *)
-(*                                                                       *)
-(*************************************************************************)
 
-let verified_bitmap t = t.t_converted_verified_bitmap
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         set_verifier                                  *)
-(*                                                                       *)
-(*************************************************************************)
 
 let set_verifier t f =
   t.t_verifier <- f;
-(* TODO: check that false as primary is a good value to start with *)
-  set_verified_bitmap false t t.t_converted_verified_bitmap
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         set_verifier                                  *)
-(*                                                                       *)
-(*************************************************************************)
+(* TODO: check that false as t_primary is a good value to start with *)
+  set_chunks_verified_bitmap t t.t_converted_verified_bitmap
 
 let set_verified t f =
   t.t_verified <- f
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         downloaded                                    *)
-(*                                                                       *)
-(*************************************************************************)
-
 let downloaded t = file_downloaded t.t_file
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         block_block                                   *)
-(*                                                                       *)
-(*************************************************************************)
-
-let block_num t b =
-  let n = t.t_chunk_of_block.(b.block_num) in
-  n
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         partition_size                                *)
-(*                                                                       *)
-(*************************************************************************)
+let block_chunk_num t b =
+  t.t_chunk_of_block.(b.block_num)
 
 let partition_size t = String.length t.t_converted_verified_bitmap
 
 let uploader_swarmer up = up.up_t
 
+(** Return the availability of the chunks of [t] as a string *)
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         availability                                  *)
-(*                                                                       *)
-(*************************************************************************)
-
-let availability t =
-
+let chunks_availability t =
   let s = t.t_s in
-  let len = String.length t.t_converted_verified_bitmap in
-  let str = String.make len '\000' in
-  for i = 0 to len - 1 do
-    str.[i] <- char_of_int (
+  string_init (partition_size t) (fun i ->
+    char_of_int (
       let v = List2.min
-          (List.map (fun i -> s.s_availability.(i)) t.t_blocks_of_chunk.(i)) in
+        (List.map (fun i -> s.s_availability.(i)) t.t_blocks_of_chunk.(i)) in
       if v < 0 then 0 else
-      if v > 200 then 200 else v)
-  done;
-  str
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         is_interesting                                *)
-(*                                                                       *)
-(*************************************************************************)
-
-(*return true if s is interesting for p1
-    NB: works when s is a mask of 0s(absent bloc) and 1s(present bloc)
-    p1 can be a string 0(absent) 1(partial) 2(present unverified) or
-      3(present verified)
-                        s : 00001111
-                       p1 : 01230123
-           is_interesting : 00001110
-*)
+	if v > 200 then 200 else v))
 
 let is_interesting up =
   up.up_ncomplete > 0 || up.up_npartial > 0
@@ -2735,7 +2595,7 @@
 
 let value_to_int64_pair v =
   match v with
-    List [v1;v2] | SmallList [v1;v2] ->
+  | List [v1;v2] | SmallList [v1;v2] ->
       (value_to_int64 v1, value_to_int64 v2)
   | _ ->
       failwith "Options: Not an int32 pair"
